<?php

/*
* @param string $url Link do WebService
* @param string $parameters base64 com os parametros para a requisição
* @param string $tokenLogin token de login em caso de rotas autenticadas
**/
$url = $argv[1];

$parameters = isset($argv[2]) ? $argv[2] : array();
$tokenLogin = isset($argv[3]) ? $argv[3] : array();

if($parameters) $parameters = base64_decode($parameters);

asyncRequest($url, $parameters, $tokenLogin, true);

function asyncRequest($url, $parameters = '', $tokenLogin, $debugMode = false) 
{

	$values = array();
	
	error_reporting(E_ALL);
    
    /* Get the port for the WWW service. */
    $service_port = getservbyname('www', 'tcp');
    $url     = parse_url($url);
    
    /* Get the IP address for the target host. */
    $address = $url['host'];
    /* Create a TCP/IP socket. */
    $socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
    if ($socket === false) {
        throw new \Exception("Não foi possivel realizar a requisição para $url.");
    } 
    
    $result = socket_connect($socket, $address, $service_port);
    
    if ($result === false) {
        throw new \Exception("Não foi possivel realizar a requisição para $url.");
    } 

	$in = "POST ".$url['path']." HTTP/1.1\r\n";
	$in.= "Host: ".$url['host']."\r\n";
	$in.= "Content-Type: application/json\r\n";
	$in.= "OAuth-Token: $tokenLogin\r\n";
	$in.= "Content-Length: ".strlen($parameters)."\r\n";
	$in.= "Connection: Close\r\n\r\n";
	if ($parameters) $in.= $parameters;
	$out = '';

    socket_write($socket, $in, strlen($in));
    
    if($debugMode === true) {
        while ($out = socket_read($socket, 2048)) {
            var_dump($out);
        }
    }

    socket_close($socket);
}
    