function CalcNecessidadeCompraController(ScreenService, NecessidadeCompraService, Parametros, ZHPromise, General, localStorageEngine, MessageService) {

    var self = this;
    var params = [];
    var todasUnidades;
    var dtentrneccmp;
    var cdGrupoProd;
    var dataUtilizacao;
    var calcPrevConsumo;
    var dataProcessamento;
    var onEnterOnce = true;
    var onEnterOnceHist = true;

    this.parametros = function (widget) {

        var cdfilial = getLocalVar('CDFILIAL');
        var centralCompras;
        var promises = [];
        todasUnidades = '';

        localStorageEngine.getDataSource('/unidades').then(function(unidades) {
            unidades.forEach(function(unidade){
                todasUnidades += unidade.CDFILIAL+'_';
                if(unidade.CDFILIAL == cdfilial){
                    centralCompras = unidade.CDFILCENTCMP;
                }
            });

            promises.push(Parametros.parasupri(centralCompras));

            promises.push(Parametros.parcmpsup(getLocalVar('CDFILIAL')));

            promises.push(Parametros.paramgeral());

            ZHPromise.all(promises).then(function (callback) {
                cdGrupoProd = callback[0].dataset.parasupri.length ? callback[0].dataset.parasupri[0].CDGRUPPROD : 'N';
                dataUtilizacao = callback[0].dataset.parasupri.length ? callback[0].dataset.parasupri[0].IDULTIDTULTI : 'N';
                calcPrevConsumo = callback[1].dataset.parcmpsup[0].IDCALPREVCON;

                var infoPerAcrescimo = callback[1].dataset.parcmpsup[0].IDPERACRNEC;
                var calcPeriodicidade = callback[2].dataset.paramgeral[0].IDSISDOS;

                self.controlaAcrescimo(widget, infoPerAcrescimo);
                self.controlaPeriodicidade(widget, calcPeriodicidade);
                widget.getField('NMSUBGRPROD').reload();
            });

        });

    };


    //CALCULO DA NECESSIDADE DE COMPRAS

    this.valorDefaultRelatorios = function(widget){
        if(onEnterOnce) {
            widget.currentRow.CD_REPORT_NAME = widget.getField('REPORT_NAME').dataSource.getFirstRow().valor;
            widget.currentRow.REPORT_NAME = widget.getField('REPORT_NAME').dataSource.getFirstRow().nome;
            onEnterOnce = false;
        }
    };

    this.valorDefaultCalcNeceComp = function(widget){
        Parametros.retornaDataProcessamento().then(function(callback){
            dataProcessamento = callback;
            widget.currentRow.NMGRUPFILI = '';
            widget.currentRow.TCDFILIAL = '';
            //widget.getField('TCDFILIAL').checked = true;
            widget.getField('DTENTREGAINI').setValue(moment(dataProcessamento,'L').format('DD/MM/YYYY'));
            widget.getField('DTENTREGAFIN').setValue(moment(dataProcessamento,'L').format('DD/MM/YYYY'));
            widget.currentRow.NMSUBGRPROD = '';
            widget.currentRow.NMPRODINICIAL = '';
            widget.currentRow.NMPRODFINAL = '';
            widget.currentRow.PEACRESCIMO = '0';
            widget.getField('SOLIEXTRA').checked = false;
            //General.toggleReadOnlySelect(widget.getField('TCDFILIAL'), widget.getField('CDFILIAL'));
        });
    };

    this.valorDefaultHistNeceComp = function(widget){
        if(onEnterOnceHist) {
            widget.currentRow.CD_REPORT_NAME = widget.getField('REPORT_NAME').dataSource.getFirstRow().valor;
            widget.currentRow.REPORT_NAME = widget.getField('REPORT_NAME').dataSource.getFirstRow().nome;
            widget.getField('TNMFILIAL').checked = true;
            General.toggleReadOnlySelect(widget.getField('TNMFILIAL'), widget.getField('NMFILIAL'));
            widget.getField('TNMOPERADOR').checked = true;
            General.toggleReadOnlySelect(widget.getField('TNMOPERADOR'), widget.getField('NMOPERADOR'));
            widget.getField('DTENTREGAINI').setValue(moment().format('DD/MM/YYYY'));
            widget.getField('DTENTREGAFIN').setValue(moment().format('DD/MM/YYYY'));
            widget.getField('DTGERACAOINI').setValue(moment().format('DD/MM/YYYY'));
            widget.getField('DTGERACAOFIN').setValue(moment().format('DD/MM/YYYY'));
            onEnterOnceHist = false;
        }
    };

    this.calculaNecessidade = function (widget) {
        if (widget.isValid() && self.validaData(widget.currentRow.DTENTREGAINI, widget.currentRow.DTENTREGAFIN) && self.verificaDtProcessamento(widget.currentRow.DTENTREGAINI) && self.validaProduto(widget.currentRow.CDPRODINICIAL, widget.currentRow.CDPRODFINAL) && self.limitaNumeroFilial(widget.currentRow.CDFILIAL)) {
            params = {
                "CDFILIAL": self.montaLista(widget.currentRow.CDFILIAL, '', widget.currentRow.UNIDADES),
                "TCDFILIAL": '',
                "CDGRUPFILI": '',
                "DTINICIAL": widget.currentRow.DTENTREGAINI,
                "DTFINAL": widget.currentRow.DTENTREGAFIN,
                "CDPRODINI": widget.currentRow.CDPRODINICIAL,
                "CDPRODFIN": widget.currentRow.CDPRODFINAL,
                "PEACRESCIMO": widget.currentRow.PEACRESCIMO,
                "CDOPERADOR": getLocalVar('CDOPERADOR'),
                "EXTRA": widget.currentRow.SOLIEXTRA,
                "NRORG": getLocalVar('NRORG'),
                "CDGRUPPROD": cdGrupoProd,
                "CDSUBGRUPO": self.montaListaSubgrupo(widget.currentRow.NMSUBGRPROD),
                "IDQTDEZERO": 'S',
                "DTHRCALCNC": '',
                "DTCALCULO": '',
                "GERASOLICITA": ''
            };

            if (calcPrevConsumo == 'S') {
                this.calculaDataPrevisaoConsumo().then(function (data) {
                    params.DTCALCULO = data;
                    var mensagem = ScreenService.i18n("Deseja calcular a previsão de consumo no período entre as datas de processamento de cada unidade e o dia ");
					mensagem += ' ' + data + '?';
                    if (widget.currentRow.CDFILIAL.length == 1) {
                        var widgetCalcPrevisao = widget.container.getWidget('tab_cmp03000_calcular_previsao_consumo');
                        widgetCalcPrevisao.getField('CALCPREVCONSUMO').label = mensagem;
                        ScreenService.openPopup(widgetCalcPrevisao);
                        params.GERASOLICITA = 'N';
                    } else {
                        var widgetRelatorio = widget.container.getWidget('tab_cmp03001_relatorio_previa_necessidade_compra');
                        widgetRelatorio.getField('CALCPREVCONSUMO').label = mensagem;
                        ScreenService.openPopup(widgetRelatorio);
                        params.GERASOLICITA = 'S';
                    }
                });
            } else {
                if (widget.currentRow.CDFILIAL.length == 1) {
                    params.GERASOLICITA = 'N';
                    self.confirmaCalculoNecessidade(widget, widget);
                } else {
                    params.GERASOLICITA = 'S';
                    var widgetRelatorio = widget.container.getWidget('tab_cmp03001_relatorio_previa_necessidade_compra');
                    widgetRelatorio.getField('CALCPREVCONSUMO').isVisible = false;
                    ScreenService.openPopup(widgetRelatorio);
                }
            }
        }
    };

    var proceCalculaPrevconsFiliais = function (prevConsumo) {
        var deferred = ZHPromise.defer();

        if (prevConsumo == 1) {
            NecessidadeCompraService.proceCalculaPrevconsFiliais(params).then(function () {
                deferred.resolve();
            },function(error){
                ScreenService.showMessage(error.data.error);
            });
        } else {
            deferred.resolve();
        }

        return deferred;
    };

    var procePeriodicidadeNaoCalculada = function (periodicidade) {
        var deferred = ZHPromise.defer();

        if (periodicidade == 'S') {
            NecessidadeCompraService.procePeriodicidadeNaoCalculada(params).then(function () {
                deferred.resolve();
            });
        } else {
            deferred.resolve();
        }

        return deferred;
    };

    var proceGeraSolicitacao = function (geraSoli) {
        var deferred = ZHPromise.defer();

        if (geraSoli == 'S') {
            NecessidadeCompraService.proceGeraSolicitacao(params).then(function () {
                deferred.resolve();
            });
        } else {
            deferred.reject();
        }

        return deferred;
    };

    this.relatorioPreviaNecessidadeCompra = function (widget, geraSoli) {
        var deferred = ZHPromise.defer();
        var promises = [];

        if (geraSoli == 'S') {
            NecessidadeCompraService.listaUnidades(params.NRNECECOMP, params.NRORG).then(function (listaUnidades) {
                var reportName = widget.currentRow.CD_REPORT_NAME;
                if (reportName == 'cmp03800') {
                    for (i = 0; i < listaUnidades.dataset.trabnececomp_distinct.length; i++) {
                        row = {
                            "DATAINI": params.DTINICIAL,
                            "DATAFIN": params.DTFINAL,
                            "FILIPROC": getLocalVar('CDFILIAL'),
                            "NRNECECOMP": params.NRNECECOMP,
                            "CDFILIAL": listaUnidades.dataset.trabnececomp_distinct[i].CDFILNECECMP
                        };
                        promises.push(NecessidadeCompraService.openReportSemMensagem('/cmp03800', reportName, row));
                    }
                } else {
                    for (i = 0; i < listaUnidades.dataset.trabnececomp_distinct.length; i++) {
                        row = {
                            "NRNECECOMP": params.NRNECECOMP,
                            "CDFILIAL": listaUnidades.dataset.trabnececomp_distinct[i].CDFILNECECMP
                        };
                        promises.push(NecessidadeCompraService.openReportSemMensagem('/cmp03800', reportName, row));
                    }
                }
                ZHPromise.all(promises).then(function(){
                    deferred.resolve();
                    ScreenService.closePopup();
                });
            });
        } else {
            deferred.resolve();
        }

        return deferred;
    };

    this.confirmaCalculoNecessidade = function (widgetPopup, widgetCalc) {
        if (widgetPopup.isValid()) {
            params.DTHRCALCNC = moment().format('DD/MM/YYYY hh:mm:ss');
            proceCalculaPrevconsFiliais(widgetPopup.currentRow.CALCPREVCONSUMO).then(function () {
                procePeriodicidadeNaoCalculada(widgetCalc.currentRow.CALCPERIODICIDADE).then(function () {
                    NecessidadeCompraService.proceNecessidadeDeCompras(params).then(function (callback) {
                        params.NRNECECOMP = callback.dataset.nrnececomp[0];
                        self.relatorioPreviaNecessidadeCompra(widgetPopup, params.GERASOLICITA).then(function () {
                            proceGeraSolicitacao(params.GERASOLICITA).then(function(){
                                self.excluiTrabnececomp();
                                MessageService.successNotificationByCode("SOL_CMP_SUCCESS_INSERT");
                            }, function () {
                                if(params.GERASOLICITA == 'N') {
                                    ScreenService.openWindow('cmp_V1#cmp03001');
                                }
                            });
                        });
                    });
                });
            });
        }
    };

    this.calculaDataPrevisaoConsumo = function () {
        var paramsQuery = Util.clone(params);
        paramsQuery.CDPRODFIN = paramsQuery.CDPRODFIN.padEnd(20,'Z');
        return NecessidadeCompraService.dataPrevisaoConsumo(paramsQuery).then(function (callback) {
            var data = paramsQuery.DTFINAL;
            data = moment(data, 'DD/MM/YYYY').add(1, 'month');
            data = moment(data, 'DD/MM/YYYY').add(callback.dataset.cmp03000_calculodata[0].MAXLIMISEG, 'day').format('DD/MM/YYYY');

            return data;
        });
    };

    this.controlaAcrescimo = function (widget, infoPerAcrescimo) {
        if (infoPerAcrescimo == 'N') {
            widget.getField('PEACRESCIMO').readOnly = true;
        } else {
            widget.getField('PEACRESCIMO').readOnly = false;
        }
    };

    this.controlaPeriodicidade = function (widget, calcPeriodicidade) {
        if (calcPeriodicidade == 3) {
            widget.getField('CALCPERIODICIDADE').readOnly = true;
            widget.getField('CALCPERIODICIDADE').setValue('S');
        } else {
            widget.getField('CALCPERIODICIDADE').readOnly = false;
        }
    };

    this.verificaDtProcessamento = function(dtinicial) {
        if(moment(dtinicial, 'DD/MM/YYYY') >= moment(dataProcessamento, 'L')) {
            return true;
        } else {
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            return false;
        }
    };

    this.limitaNumeroFilial = function(unidades) {
        if(unidades.length > 70) {
            MessageService.showMessageByCode("AJUSTE_FILTRO_MENOR_UNIDADE");
            return false;
        } else {
            return true;
        }
    };

    this.relatorioHistoricoNecessidadeCompra = function (widget) {
        if (widget.isValid() && self.validaData(widget.currentRow.DTGERACAOINI, widget.currentRow.DTGERACAOFIN) && self.validaData(widget.currentRow.DTENTREGAINI, widget.currentRow.DTENTREGAFIN)) {
            var reportName = widget.currentRow.CD_REPORT_NAME;
            var row = {
                "CDFILIAL": self.montaLista(widget.currentRow.NMFILIAL, widget.currentRow.TNMFILIAL, widget.currentRow.UNIDADES),
                "CDFILIAL2": self.montaLista(widget.currentRow.NMFILIAL, widget.currentRow.TNMFILIAL, widget.currentRow.UNIDADES),
                "CDGRUPFILI": '',
                "CDOPERADOR": self.montaListaOperador(widget.currentRow.NMOPERADOR, widget.currentRow.TNMOPERADOR),
                "DTINI": widget.currentRow.DTGERACAOINI,
                "DTFIN": widget.currentRow.DTGERACAOFIN,
                "DTENTRINICIAL": widget.currentRow.DTENTREGAINI,
                "DTENTRFINAL": widget.currentRow.DTENTREGAFIN
            };

            if(reportName == 'cmp03004'){
                row.CDOPERADOR1 = self.montaListaOperador(widget.currentRow.NMOPERADOR, widget.currentRow.TNMOPERADOR);
            }

            General.openReport('/cmp03000', reportName, row);
        }
    };


    //NECESSIDADE DE COMPRAS

    this.abreListaProduto = function (currentRow, widget) {
        var dataSourceFilter = [];
        dataSourceFilter = [
            {"name": "NRNECECOMP",      "value": params.NRNECECOMP,         "operator": "="},
            {"name": "DTENTRNECCMP",    "value": currentRow.DTENTRNECCMP,   "operator": "="},
            {"name": "CDFILNECECMP",    "value": currentRow.CDFILNECECMP,   "operator": "="},
            {"name": "NRORG",           "value": currentRow.NRORG,          "operator": "="},
            {"name": "QTPRACOMPRAR",    "value": 0,                         "operator": ">" }
        ];

        widget.dataSourceFilter = dataSourceFilter;
        ScreenService.openSwipe(widget);
        widget.activate();
        widget.reload();
    };

    this.abreListaData = function (currentRow, widget) {
        var dataSourceFilter = [];
        dataSourceFilter = [
            {"name": "NRNECECOMP",      "value": params.NRNECECOMP,         "operator": "=" },
            {"name": "CDPRODNECCMP",    "value": currentRow.CDPRODNECCMP,   "operator": "=" },
            {"name": "CDFILNECECMP",    "value": currentRow.CDFILNECECMP,   "operator": "=" },
            {"name": "NRORG",           "value": currentRow.NRORG,          "operator": "=" },
            {"name": "QTPRACOMPRAR",    "value": 0,                         "operator": ">" },
            {"name": "DTINICIAL",       "value": params.DTINICIAL,          "operator": "=" }
        ];

        widget.dataSourceFilter = dataSourceFilter;
        ScreenService.openSwipe(widget);
        widget.activate();
        widget.reload();
        widget.restoreDefaultMode();
    };

    function aplicaDistinct(dados, nomeField) {
        var dadosDistinct = [];
        if (dados && dados.length) {
            dados.forEach(function (linha) {
                var filtered = dadosDistinct.filter(function (linhaFilter) {
                    return linhaFilter[nomeField] == linha[nomeField];
                });
                if (!filtered.length) dadosDistinct.push(linha);
            });
        }
        return dadosDistinct;
    }

    this.carregarNecessidade = function (widget, nomeField) {
        widget.reload().then(function () {
            widget.dataSource.data = aplicaDistinct(widget.dataSource.data, nomeField);
        });
    };

    this.insereNecessidadeCompra = function (widget) {
        widget.newRow = function () {
            var event;
            if (this.beforeNewRow) {
                event = this.beforeNewRow();
            }
            if (!event || !event.isDefaultPrevented()) {

                var _oldValuesToRepeat = this.getRepeatOnNewValues();
                var row = {};
                if (this.dataSource) {
                    this.dataSource.newRow();
                    row = this.dataSource.data[this.dataSource.data.length - 1];
                }
                this.currentRow = row;
                this.applyDefaultValue();
                Util.extend(this.currentRow, _oldValuesToRepeat);
                this.edit();
                this.formTemplate = this.templateToForm;
                if (this.onNewRow) {
                    this.onNewRow();
                }
            }
        };

        widget.newRow();
        ScreenService.openSwipe(widget);
    };

    this.insereProdutoData = function (widget) {
        widget.edit();
        widget.formTemplate = widget.templateToForm;
        ScreenService.openSwipe(widget);
    };

    this.salvaNecessidadeCompra = function (widget) {
        if (widget.isValid() && self.validaNovoItem(widget.dataSource.data, widget.currentRow, widget.name) && self.validaDataPeriodo(widget.currentRow.DTENTRNECCMP)) {
            widget.currentRow.QTPRCNVCOMPR = parseFloat(widget.currentRow.QTPRCNVCOMPR.replace(/\./g, '').replace(',', '.'));
            widget.currentRow.QTPRACOMPRAR = widget.currentRow.QTPRCNVCOMPR;
            widget.saveRow();
            ScreenService.closeSwipe();
            widget.list();
            widget.activate();
        }
    };

    this.salvaProdutoNecessidade = function (widget) {
        if (widget.isValid() && self.validaNovoItem(widget.container.getWidget('tab_cmp03001_calculo_necessidade_lista_produtos').dataSource.data, widget.currentRow, widget.name)) {
            rowCalcNecessidadeData = widget.container.getWidget('tab_cmp03001_calculo_necessidade_por_data').currentRow;
            widget.currentRow.DTENTRNECCMP = rowCalcNecessidadeData.DTENTRNECCMP;
            widget.currentRow.NRNECECOMP = rowCalcNecessidadeData.NRNECECOMP;
            widget.currentRow.CDFILNECECMP = rowCalcNecessidadeData.CDFILNECECMP;
            widget.currentRow.IDMARCNECCMP = rowCalcNecessidadeData.IDMARCNECCMP;
            widget.currentRow.QTPRCNVCOMPR = parseFloat(widget.currentRow.QTPRCNVCOMPR.replace(/\./g, '').replace(',', '.'));
            widget.currentRow.QTPRACOMPRAR = widget.currentRow.QTPRCNVCOMPR;
            widget.saveRow().then(function () {
                widget.currentRow.__is_new = false;
                widget.currentRow.changed = false;
                widget.list(true);
                widget.container.getWidget('tab_cmp03001_calculo_necessidade_lista_produtos').activate();
                self.carregarNecessidade(widget.container.getWidget('tab_cmp03001_calculo_necessidade_lista_produtos'), 'CDARVPROD');
            });
        }
    };

    this.salvaDataNecessidade = function (widget) {
        if (widget.isValid() && self.validaNovoItem(widget.container.getWidget('tab_cmp03001_calculo_necessidade_lista_data').dataSource.data, widget.currentRow, widget.name) && self.validaDataPeriodo(widget.currentRow.DTENTRNECCMP)) {
            rowCalcNecessidadeProd = widget.container.getWidget('tab_cmp03001_calculo_necessidade_por_produto').currentRow;
            widget.currentRow.CDPRODNECCMP = rowCalcNecessidadeProd.CDPRODNECCMP;
            widget.currentRow.NRNECECOMP = rowCalcNecessidadeProd.NRNECECOMP;
            widget.currentRow.CDFILNECECMP = rowCalcNecessidadeProd.CDFILNECECMP;
            widget.currentRow.IDMARCNECCMP = rowCalcNecessidadeProd.IDMARCNECCMP;
            widget.currentRow.QTPRCNVCOMPR = parseFloat(widget.currentRow.QTPRCNVCOMPR.replace(/\./g, '').replace(',', '.'));
            widget.currentRow.QTPRACOMPRAR = widget.currentRow.QTPRCNVCOMPR;
            widget.saveRow().then(function () {
                widget.currentRow.__is_new = false;
                widget.currentRow.changed = false;
                widget.list(true);
                widget.container.getWidget('tab_cmp03001_calculo_necessidade_lista_data').activate();
                self.carregarNecessidade(widget.container.getWidget('tab_cmp03001_calculo_necessidade_lista_data'), 'DTENTRNECCMP');
            });
        }
    };

    this.salvaEdicaoNecessidade = function (widget){
        if (widget.isValid() && self.validaNovoItem(widget.dataSource.data, widget.currentRow, widget.name)) {
            widget.currentRow.QTPRCNVCOMPR = parseFloat(widget.currentRow.QTPRCNVCOMPR.replace(/\./g, '').replace(',', '.'));
            widget.currentRow.QTPRACOMPRAR = widget.currentRow.QTPRCNVCOMPR;
            widget.saveRow().then(function () {
                self.cancelaEdicaoNecessidade(widget);
            });
        }
    };

    this.cancelaEdicaoNecessidade = function (widget){
        widget.currentRow.__is_new = false;
        widget.currentRow.changed = false;
        widget.list();
        widget.formTemplate = widget.template;
        widget.activate();
        if(widget.name == 'tab_cmp03001_calculo_necessidade_lista_data'){
            self.carregarNecessidade(widget, 'DTENTRNECCMP');
        } else {
            self.carregarNecessidade(widget, 'CDARVPROD');
        }
    };

    this.excluiNecessidadeCompra = function (widget) {
        nomeWidget = widget.name;
        rowsNecessidade = widget.getCheckedRows();
        NecessidadeCompraService.excluiNecessidadeCompra(rowsNecessidade, nomeWidget).then(function (callback) {
            if (nomeWidget == 'tab_cmp03001_calculo_necessidade_por_data') {
                self.carregarNecessidade(widget, 'DTENTRNECCMP');
            } else {
                self.carregarNecessidade(widget, 'CDARVPROD');
            }
            MessageService.showMessageByCode("REG_SUCCESS_DELETE");
        });
    };

    this.editaNecessidadeCompra = function(widget){
        widget.edit();
        widget.getField('NMPRODUTO').readOnly = true;
        widget.getField('SGUNIDADE').readOnly = true;
        widget.getField('DTPRIUTIPROD').readOnly = true;
        widget.getField('DTENTRNECCMP').readOnly = true;
    };

    this.geraSolicitacao = function(widget){
        params.GERASOLICITA = 'S';
        if(widget.isValid()) {
            self.relatorioPreviaNecessidadeCompra(widget, params.GERASOLICITA).then(function () {
                proceGeraSolicitacao(params.GERASOLICITA).then(function(){
                    self.excluiTrabnececomp();
                    ScreenService.goBack();
                    MessageService.successNotificationByCode("SOL_CMP_SUCCESS_INSERT");
                });
            });
        }
    };

    this.fechaSwipe = function (widget) {
        if (widget.lastActiveWidget) {
            if (widget.name != widget.lastActiveWidget.name) {
                ScreenService.closeSwipe();
                widget.activate();
            }
        }
    };

    this.setDataUtilizacao = function (widget){
        var data = widget.getField('DTENTRNECCMP').value();
        widget.getField('DTPRIUTIPROD').setValue(data);
    };

    this.controlaDataUtilizacao = function (widget) {
        if (dataUtilizacao == 'S') {
            widget.getField('DTPRIUTIPROD').isVisible = true;
        } else {
            widget.getField('DTPRIUTIPROD').isVisible = false;
        }
    };

    this.validaNovoItem = function(dataSet, item, widgetName){
        var dataSetExistente, existe, mensagem;
        switch (widgetName) {
            case 'tab_cmp03001_calculo_necessidade_por_data':
            case 'tab_cmp03001_insere_datas':
                dataSetExistente = dataSet.map(function (datas) {
                    return datas.DTENTRNECCMP;
                });
                existe = dataSetExistente.indexOf(item.DTENTRNECCMP);
                mensagem = 'Data já cadastrada.';
                break;
            case 'tab_cmp03001_calculo_necessidade_por_produto':
            case 'tab_cmp03001_insere_produtos':
                dataSetExistente = dataSet.map(function (datas) {
                    return datas.CDPRODNECCMP;
                });
                existe = dataSetExistente.indexOf(item.CDPRODNECCMP);
                mensagem = 'Produto já cadastrado.';
                break;
            default:
                existe = '-1';
                break;
        }

        if(existe == '-1'){
            var quantidade = item.QTPRCNVCOMPR.replace(/\./g, '').replace(',', '.');
            if(quantidade > 0){
                return true;
            } else {
                MessageService.showMessageByCode("QTD_MAIOR_ZERO");
                return false;
            }
        } else{
            ScreenService.showMessage(ScreenService.i18n(mensagem));
            return false;
        }
    };

    this.validaDataPeriodo = function(dtNecessidade){
        var dtInicial = params.DTINICIAL;
        var dtFinal = params.DTFINAL;

        var representacoes = {
            "dtInicial": dtInicial,
            "dtFinal": dtFinal
        };

        if(moment(dtNecessidade, 'DD/MM/YYYY') >= moment(dtInicial, 'DD/MM/YYYY') && moment(dtNecessidade, 'DD/MM/YYYY') <= moment(dtFinal, 'DD/MM/YYYY')) {
            return true;
        } else {
            MessageService.showMessageByCode("DTA_ENTRE_DTINICIAL_DTFINAL", { "DTINICIAL": dtInicial, "DTFINAL": dtFinal });
            return false;
        }
    };

    this.controlaUnidade = function(widget) {
        var fieldFilial = widget.getField('CDFILIAL');
        fieldFilial.setValue('');
        widget.currentRow.CDFILIAL = '';

        if(widget.currentRow.NMGRUPFILI) {
            fieldFilial.validations = {};
        } else {
            fieldFilial.validations = { required: true };
        }
    };


    //PREVIA DO CALCULO DA NECESSIDADE DE COMPRA

    this.parametrosPreviaCalcNeceComp = function(widget) {
        Parametros.parasupri(getLocalVar('CDFILIAL')).then(function(callback){
            cdGrupoProd = callback.dataset.parasupri.length ? callback.dataset.parasupri[0].CDGRUPPROD : 'N';
            widget.getField('NMSUBGRPROD').reload();
        });
    };

    this.valorDefaultPreviaCalcNeceComp = function(widget){
        Parametros.retornaDataProcessamento().then(function(callback){
            dataProcessamento = callback;
            widget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
            widget.getField('NMFILIAL').setValue(getLocalVar('NMFILIAL'));
            widget.getField('DTENTREGAINI').setValue(moment(dataProcessamento,'L').format('DD/MM/YYYY'));
            widget.getField('DTENTREGAFIN').setValue(moment(dataProcessamento,'L').format('DD/MM/YYYY'));
            widget.getField('NMSUBGRPROD').setValue('');
            widget.getField('NMPRODINICIAL').setValue('');
            widget.getField('NMPRODFINAL').setValue('');
            widget.getField('PEACRESCIMO').setValue('0');
            widget.getField('MANTERPRODQTZERO').setValue('S');
            self.valorDefaultRelatorios(widget);
        });
    };

    this.geraRelatorioPreviaCalcNeceComp = function (widget, args) {

        var reportName = widget.currentRow.CD_REPORT_NAME;

        if(widget.isValid() && self.validaData(widget.currentRow.DTENTREGAINI, widget.currentRow.DTENTREGAFIN) && self.verificaDtProcessamento(widget.currentRow.DTENTREGAINI) && self.validaProduto(widget.currentRow.CDPRODINICIAL, widget.currentRow.CDPRODFINAL)) {

            General.openReportPopup(widget, this.abreRelatorio, [widget, widget.currentRow, args, reportName]);
        }
    };

    this.abreRelatorio = function(widget, currentRow, args, reportName) {

        var paramProcedure = {
            "CDFILIAL": widget.currentRow.CDFILIAL,
            "TCDFILIAL": '',
            "CDGRUPFILI": '',
            "DTINICIAL": widget.currentRow.DTENTREGAINI,
            "DTFINAL": widget.currentRow.DTENTREGAFIN,
            "CDPRODINI": widget.currentRow.CDPRODINICIAL,
            "CDPRODFIN": widget.currentRow.CDPRODFINAL,
            "PEACRESCIMO": widget.currentRow.PEACRESCIMO,
            "CDOPERADOR": getLocalVar('CDOPERADOR'),
            "DTHRCALCNC": moment().format('DD/MM/YYYY hh:mm:ss'),
            "IDQTDEZERO": 'S',
            "EXTRA": '',
            "NRORG": getLocalVar('NRORG'),
            "CDGRUPPROD": cdGrupoProd,
            "CDSUBGRUPO": self.montaListaSubgrupo(widget.currentRow.NMSUBGRPROD)
        };

        NecessidadeCompraService.proceNecessidadeDeCompras(paramProcedure).then(function (callback) {
        
            params = {
                "DATAINI": widget.currentRow.DTENTREGAINI,
                "DATAFIN": widget.currentRow.DTENTREGAFIN,
                "FILIPROC": getLocalVar('CDFILIAL'),
                "NRNECECOMP": callback.dataset.nrnececomp[0],
                "CDFILIAL": widget.currentRow.CDFILIAL,
                "NRORG": getLocalVar('NRORG'),
                "QR2TYPE": widget.currentRow.QR2TYPE
            };

            General.openReport('/cmp03800', reportName, params).then(function () {
                self.excluiTrabnececomp();
            });
        });

    }.bind(this);


    //GERAIS

    this.excluiTrabnececomp = function(){
        NecessidadeCompraService.excluiTrabnececomp(params.NRNECECOMP, params.NRORG);
    };

    this.montaLista = function(fieldSelect, fieldTodos, unidadeAgrup){
        if (fieldSelect) {
            if(Array.isArray(fieldSelect)){
                return fieldSelect.join('_');
            } else{
                return fieldSelect;
            }
        } else {
            if(unidadeAgrup){
                var agrupamento = unidadeAgrup.split('_');
                var unidades = todasUnidades.split('_');
                return agrupamento.map(function(unidade){
                    if(unidades.indexOf(unidade) != -1){
                        return unidade;
                    }
                }).join('_');
            } else{
                return todasUnidades;
            }
        }
    };

    this.montaListaOperador = function(fieldSelect, fieldTodos){
        if (fieldTodos == 'T') {
            return fieldTodos;
        } else {
            return fieldSelect.join('_');
        }
    };

    this.montaListaSubgrupo = function(fieldSelect){
        if(Array.isArray(fieldSelect)){
            return fieldSelect.join('_');
        } else{
            return fieldSelect;
        }
    };

    this.filtraUnidadeAgrupamento = function(fieldUnidades, stringUnidades){
        if(stringUnidades) {
            var unidades = stringUnidades.split('_');
            fieldUnidades.dataSourceFilter = [
                {
                    "name": "CDFILIAL",
                    "value": "",
                    "operator": "IN"
                }
            ];
            this.defineSelectWidget(fieldUnidades);
            General.onClickDependentField(fieldUnidades, {'CDFILIAL': unidades});
        } else{
            fieldUnidades.dataSourceFilter = [
                {
                    "name": "NRORG",
                    "value": "",
                    "operator": "="
                }
            ];
            this.defineSelectWidget(fieldUnidades);
            General.onClickDependentField(fieldUnidades, {'NRORG': getLocalVar('NRORG')});
        }
    };

    this.defineSelectWidget = function(field){
        if(field.selectWidget){
            field.selectWidget.dataSourceFilter = field.dataSourceFilter;
        }
    };

    this.validaData = function(dtInicial, dtFinal) {
        var dataInicial = dtInicial ? moment(dtInicial, 'DD/MM/YYYY')._d : null;
        var dataFinal = dtFinal ? moment(dtFinal, 'DD/MM/YYYY')._d : null;

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            return false;
        }
        return true;
    };

    this.validaProduto = function(prodInicial, prodFinal) {
        
        if(!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        } 

        return true;
    };

    this.getCdGrupoProd = function () {
        return cdGrupoProd;
    };

    this.getNrnececomp = function () {
        return params.NRNECECOMP;
    };

    this.getDtinicial = function () {
        return params.DTINICIAL;
    };

    this.getDtfinal = function () {
        return params.DTFINAL;
    };

    this.setDtentrneccmp = function(field) {
        dtentrneccmp = field;
    };

    this.getDtentrneccmp = function(widget) {
        widget.getField('DTPRIUTIPROD').setValue(dtentrneccmp);
    };

    this.getCdfilial = function() {
        return params.CDFILIAL;
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register('CalcNecessidadeCompraController', CalcNecessidadeCompraController);
});