function cmp04700_fornecedor_nao_atende_atendeController(General, RestEngine, ScreenService, MessageService, templateManager, ZHPromise, ZhFilterPreferences){
    /*global Constants*/
    var self = this;
    
    this.concatArrayForParams = function (arr, defaultValue) {
        return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue ;
    };
    
    this.setDataSourceFilter = function(args) {
        const row = args.e.preference.FILTER_ROW;
        const widget = args.owner;
        let otherWidget;
        
        if (widget.name == templateManager.container.getWidget('atende').name) {
            otherWidget = templateManager.container.getWidget('naoAtende');
        } else {
            otherWidget = templateManager.container.getWidget('atende');
        }
        
        widget.dataSourceFilter = [
		    {
		        "name": "P_CDFILIAL",
		        "operator": "=",
		        "value": row.CDFILIAL
		    },
		    {
		        "name": "P_NRORG",
		        "operator": "=",
		        "value": getLocalVar('NRORG')
		    }   
		];
		
		otherWidget.dataSourceFilter = [
		    {
		        "name": "P_CDFILIAL",
		        "operator": "=",
		        "value": row.CDFILIAL
		    },
		    {
		        "name": "P_NRORG",
		        "operator": "=",
		        "value": getLocalVar('NRORG')
		    }    
		];
		
		otherWidget.appliedFilter = widget.appliedFilter;
		
		self.setStripeValues(widget);
		
		widget.reload();
		widget.activate();
    };
    
    this.setStripeValues = function(widget) {
        const stripe = templateManager.container.getWidget('stripe');
        const filterRow = widget.appliedFilter.FILTER_ROW;
        
        stripe.currentRow.CDFILIAL = filterRow.CDFILIAL;
        stripe.currentRow.NMFILIAL = filterRow.NMFILIAL;
        
        stripe.reload();
    };
    
    this.setCustomFilter = function(args) {
        args.e.preference.CUSTOM_FILTER_ROW = [];
    };
    
    this.openSubGridFilter = function(widget) {
        const subGridwidget = templateManager.container.getWidget('atendeSubGrid');
        const currentRowWidget = widget.currentRow;
        
        ScreenService.openSwipe(subGridwidget);
        
        subGridwidget.dataSourceFilter = [
        	{
        		"name": "P_SGESTADO",
		        "operator": "=",
		        "value": currentRowWidget.SGESTADO	
        	},
        	{
        		"name": "P_CDMUNICIPIO",
		        "operator": "=",
		        "value": currentRowWidget.CDMUNICIPIO	
        	},
        	{
        		"name": "P_CDFORNECED",
		        "operator": "=",
		        "value": currentRowWidget.CDFORNECED	
        	},
        	{
        		"name": "P_CDPAIS",
		        "operator": "=",
		        "value": currentRowWidget.CDPAIS	
        	}
        ];
    };
    
    this.openFormSubGrid = function(widget) {
        const formSubGridwidget = templateManager.container.getWidget('formSubGrid');
        const currentRowSubGridWidget = formSubGridwidget.currentRow;
        const currentRowWidget = widget.currentRow;
        
        ScreenService.openSwipe(formSubGridwidget).then(function(success) {
            //formSubGridwidget.getField('CDPERIENTR').clearValue();
        	formSubGridwidget.view();
        });
        
        currentRowSubGridWidget.CDFILIAL = currentRowWidget.CDFILIAL;
        currentRowSubGridWidget.NMFILIAL = currentRowWidget.NMFILIAL;
        currentRowSubGridWidget.CDPERIENTR = currentRowWidget.CDPERIENTR;
        currentRowSubGridWidget.NMPERIENTR = currentRowWidget.NMPERIENTR;
        currentRowSubGridWidget.IDUTCALENDCMPGERACAOAF = currentRowWidget.IDUTCALENDCMPGERACAOAF;
    };
    
    this.saveCodPeri = function(widget) {
        if (widget.isValid()) {
            const currentRowWidget = widget.currentRow;
            const parentWidget = widget.getParent();
            
            currentRowWidget.CDPERIENTR = currentRowWidget.CDPERIENTR.trim();
        	currentRowWidget.CDFORNECED = parentWidget.currentRow.CDFORNECED;
        	currentRowWidget.CDFILIAL = parentWidget.appliedFilter.FILTER_ROW.CDFILIAL;
        	currentRowWidget.NRORG = getLocalVar('NRORG');
        	
        	General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/saveCodPeri','Row', currentRowWidget).then(function(success) {
    	        MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
        	    widget.view();
        	}, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.saveFornecedor = function(widget) {
        if (widget.isValid()) {
            let currentRowWidget = widget.currentRow;
            const parentWidget = widget.getParent();
            
            currentRowWidget.CDFILIAL = parentWidget.appliedFilter.FILTER_ROW.CDFILIAL;
            currentRowWidget.NRORG = getLocalVar('NRORG');
            
        	General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/saveFornecedor','Row', currentRowWidget).then(function(res) {
        	   currentRowWidget = {};
        	   MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
        	   ScreenService.closeSwipe().then(function(success){
        	       parentWidget.reload();
        	   });
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.fornecedorDelete = function(widget) {
        ScreenService.confirmMessage('Deletar registro?', 'question', function (success) {
            let fornecedorArray = [];
            
            widget.dataSource.data.forEach(function(fornecedor) {
                if (fornecedor.__isSelected) {
                    fornecedorArray.push(fornecedor);
                }
            });
            
        	General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/fornecedorDelete','Row', fornecedorArray).then(function(res) {
        	       widget.unSelectAll();
        	       widget.reload();
        	       MessageService.successNotificationByCode("REG_SUCCESS_DELETE");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    this.fornecedorAtendeDelete = function(widget) {
        ScreenService.confirmMessage('Deletar registro?', 'question', function (success) {
            let fornecedorArray = [];
            
            widget.dataSource.data.forEach(function(fornecedor) {
                if (fornecedor.__isSelected) {
                    fornecedorArray.push(fornecedor);
                }
            });
            
        	General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/fornecedorAtendeDelete','Row', fornecedorArray).then(function(res) {
        	       widget.unSelectAll();
        	       widget.reload();
        	       MessageService.successNotificationByCode("REG_SUCCESS_DELETE");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    this.exportFornecedor = function(widget) {
        if (widget.isValid()) {
            const currentRowWidget = widget.currentRow;
            
            currentRowWidget.CDFILDEST = currentRowWidget.CDFILDEST ? Array.isArray(currentRowWidget.CDFILDEST) ? currentRowWidget.CDFILDEST : 'T' : 'T';
        	currentRowWidget.NRORG = getLocalVar('NRORG');
        	
        	ScreenService.confirmMessage("Deseja realizar a exportação do cadastro de fornecedor não atende/atende da unidade origem para as unidades destino selecionadas?", 'question', function(success) {
                ScreenService.confirmMessage("Todos os fornecedores que já atendem à unidade destino serão excluídos. Deseja continuar?", 'question', function(success) {
                    General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/exportFornecedor','Row', currentRowWidget).then(function(res) {
                	    MessageService.showMessageByCode("EXPORT_SUCCESS");
                	    ScreenService.closePopup();
                	    ScreenService.closePopup();
                	    widget.getParent().reload();
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });    
                }.bind(this), function(error) {});
            }.bind(this), function(error) {});
        }
    };
    
    this.generateReport = function(widget) {
        if (widget.isValid()) {
        	const reportName = widget.currentRow.REPORT;
        	const currentWidget = widget.currentRow;
        	
        	currentWidget.NRORG = getLocalVar('NRORG');
        	
        	General.openReportPopup(widget, self.abreRelatorio, [widget, currentWidget, reportName]);
        	const widgetReport = templateManager.container.getActiveWidget();
	        widgetReport.fields[0].dataSource.data.length = 2;
        }
    };
    
    this.abreRelatorio = function(widget, row, reportName) {
        row.CDFILIAL = row.CDFILIAL ? row.CDFILIAL : 'T';
        row.CDFORNECED = row.CDFORNECED ? row.CDFORNECED : 'T';
        
        General.openReport('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/generateReport', reportName, row);
    };
    
    /**
     * Redefine o dataSourceFilter da Widget de Cadastramento Automático.
     */
    this.resetFieldUnidade = function() {
        const fieldUnidade = templateManager.container.getWidget('cadAutoWidget').getField('CDFILIAL');
        
        fieldUnidade.dataSource.data = [];
    	fieldUnidade.dataSourceFilter = [
           {
               "operator": "ORDER_BY",
               "name": [
                   {
                       "name": "CDFILIAL",
                       "direction": "ASC"
                   }
                ]
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
                
            },
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
                
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": 'T'
            }
        ];
        fieldUnidade.reload();
    };
    
    this.formatForParams = function(value, defaultValue = 'T') {
        return Array.isArray(value) ? value : defaultValue;
    };
    
    this.getWidgetByTipoCadastramentoAutomatico = function(tipoCad) {
        const widgetName = tipoCad === 'N' ? 'naoAtende' : 'atende';
        
        return templateManager.container.getWidget(widgetName);
    };
    
    this.afterEndCadAutoForn = function(widgetAtual) {
        const widgetPai = self.getWidgetByTipoCadastramentoAutomatico(widgetAtual.currentRow.TIPOCAD);
        
        widgetAtual.unSelectAll();
        widgetAtual.currentRow = widgetAtual.backupRow || {};
        self.resetFieldUnidade();
        
        ScreenService.closePopup(true);
        
        widgetPai.reload();
        widgetPai.activate();
        
        MessageService.showMessageByCode("CADASTRO_SUCCESS");
        MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
    };
    
    this.cadAutoForn = function(widgetCadAutoForn) {
        if(widgetCadAutoForn.isValid()) {
            const currentRow = widgetCadAutoForn.currentRow;
            
            currentRow.CDREGIAO = self.formatForParams(currentRow.CDREGIAO);
            currentRow.CDFILIAL = self.formatForParams(currentRow.CDFILIAL);
            currentRow.CDFORNECED = self.formatForParams(currentRow.CDFORNECED);
            currentRow.CDPERIENTR = currentRow.CDPERIENTR || '';
            currentRow.NRORG = getLocalVar('NRORG');
            currentRow.QUEST = 'N';
            
            General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/cadAutoForn','Row', currentRow).then(function(res){
                if(res.length > 0) {
                    const dados = res.dataset.res;
                
                    if(dados[1].length > 0) {
                        ScreenService.confirmMessage("Atenção! Existem unidades atendidas com periodicidade diferenciada. Confirmar operação?", 'question', function(success) {
                            currentRow.QUEST = 'S';
                            General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/cadAuto', 'Row', currentRow).then(function(success) {
                                self.afterEndCadAutoForn(widgetCadAutoForn);
                            });
                        }.bind(this), function(error) {});
                    }
                } else {
                    self.afterEndCadAutoForn(widgetCadAutoForn);
                }
            }).catch(self.logErrosCadAuto);
        }
    };
    
    this.logErrosCadAuto = function (callback) {
        const gruposWidget = templateManager.container.getWidget("naoAtende");
        const errorMessages = Util.getNestedProperty(callback, ["data", "dataset", "errors"]);

        if (Array.isArray(errorMessages)) {
            gruposWidget.reload().then(function() {
                let title = 'Operação bloqueada. Existem unidades cuja região não é atendida pelos fornecedores escolhidos';
                
                if (callback.data && callback.data.error && callback.data.error) {
                    title = messages[callback.data.error] || title;
                }
                
                General.showErrorMessages(gruposWidget, errorMessages, ScreenService.i18n(title));
            });
        } 
    };
    
    this.setDefaultRelatorio = function() {
        const reportField = templateManager.container.getWidget("reportWidget").getField("REPORT");
        
        if(!reportField.value()) {
            reportField.setValue("CMP04700");
        }
    };
    
    this.setFornDestDataFilter = function(widget) {
    	const fieldRazSocDest = widget.getField("NMRAZSOCFORNDEST");
	    const fieldCdFilial = widget.getField("CDFILIAL");
    	
    	if(widget.currentRow.NMRAZSOCFORNORIG.length > 0) {
    	    fieldRazSocDest.readOnly = false;
    	    fieldCdFilial.readOnly = false;
    	    
    	    fieldRazSocDest.dataSourceFilter = [
    		    {
    		        "name": "P_CDFORNECED",
    		        "operator": "=",
    		        "value": widget.currentRow.CDFORNECEDORIG
    		    }   
    		];
    		
    		fieldCdFilial.dataSourceFilter = [
    		    {
    		        "name": "P_CDFORNECED",
    		        "operator": "=",
    		        "value": widget.currentRow.CDFORNECEDORIG
    		    }   
    		];
    		
    	} else {
    	    fieldRazSocDest.readOnly = true;
    	    fieldCdFilial.readOnly = true;
    	}
    };
    
    this.setReadOnlyFieldsReport = function(widget) {
    	if(widget.currentRow.REPORT.length > 0) {
    	    widget.getField('CDFORNECED').readOnly = false;
    	    widget.getField('CDFILIAL').readOnly = false;

    	} else {
    	    widget.getField('CDFORNECED').readOnly = true;
    	    widget.getField('CDFILIAL').readOnly = true;
    	}
    };
    
    this.setVisibleFields = function(widget) {
    	if(widget.currentRow.TIPOCAD == 'A') {
    	    widget.getField('CDPERIENTR').isVisible = true;
    	    widget.getField('NMPERIENTR').isVisible = true;
    	} else {
    	    widget.getField('CDPERIENTR').isVisible = false;
    	    widget.getField('NMPERIENTR').isVisible = false;
    	}
    	widget.reload();
    };
    
    
    this.addFornecedor = function(widget) {
        if(widget.appliedFilter.ID == 'ORIGINAL') {
            ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('naoAtende'));
            MessageService.showMessageByCode("NECE_FILIAL_FILTER");
        } else {
        	ScreenService.openSwipe(widget.widgets[0]).then(function(success) {
            	widget.widgets[0].edit();
            });
        }
    };
    
    this.edit = function() {
        templateManager.container.getWidget('formSubGrid').edit();
    };
    
    this.backSwipe = function(args) {
        const widget = args.owner.widget;
    	
    	if(widget.mode == "edit" && widget.name == "formSubGrid") {
    	    widget.view();
    	} else {
    	    widget.currentRow = {};
    	    ScreenService.closeSwipe();
    	}
    };
    
    this.backPopup = function(widget) {
    	widget.currentRow = {};
    	
    	if(widget.name == templateManager.container.getWidget('exportWidget').name) {
    	    widget.getField('CDFILDEST').readOnly = true;
    	}
    	
    	ScreenService.closePopup();
    };
    
    this.controlFildest = function(widget) {
    	if(widget.currentRow.NMFILIALORIG) {
    	    widget.getField('CDFILDEST').readOnly = false;
    	} else {
    	    widget.getField('CDFILDEST').readOnly = true;
    	}
    };
    
    this.editSwipe = function(widget) {
    	General.widgetEdit(widget);
    };
    
    this.openExportWidget = function(widget) {
    	ScreenService.openPopup(widget.widgets[1]).then(function(success){
        	widget.widgets[1].edit();
        });
    };
    
    this.openReportWidget = function() {
        const widget = templateManager.container.getWidget('naoAtende');
    	ScreenService.openPopup(widget.widgets[2]).then(function(success) {
        	widget.widgets[2].edit();
        });
    };
    
    this.openCadAutoWidget = function(widget) {
    	ScreenService.openPopup(widget.widgets[3]).then(function(success) {
    	    widget.widgets[3].backupRow = angular.copy(widget.widgets[3].currentRow);
        	widget.widgets[3].edit();
        });
    };
    
    this.setDataSourceFilterRegiao = function() {
        const widget = templateManager.container.getWidget('cadAutoWidget');
        const regiao = self.concatArrayForParams(widget.currentRow.CDREGIAO, 'T');
        const field = widget.getField('CDFILIAL');
        
        field.dataSourceFilter = [
           {
               "operator": "ORDER_BY",
               "name": [
                   {
                       "name": "CDFILIAL",
                       "direction": "ASC"
                   }
                ]
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
                
            },
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
                
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": regiao
            }
        ];
        
        field.clearValue();
        field.reload();
    };
    
    this.backPopupCadastramentoAutomatico = function() {
        templateManager.container.getWidget('cadAutoWidget').currentRow = {};
    	self.resetFieldUnidade();
    	ScreenService.closePopup();
    };
    
    
    var messages = {
        levelExists: "Impossível adicionar. Nível de pratos já cadastrado.",
        registerExists: "Impossível adicionar. Registro já existe.",
        timeout: "Tempo limite de conexão excedido.",
        unfilteredWidget: "Filtre antes de realizar esta ação.",
        addServico: "Adicione um serviço ao grupo para prosseguir.",
        addPrato: "Adicione um prato ao serviço para prosseguir.",
        duplicatedTitleOnSave: "Pratos não inseridos",
        duplicatedMessageOnSave: "__nmprato__, pois já está cadastrado para esta unidade e serviço.",
        noReceita: "Prato selecionado não possui receita.",
        noSelection: "Selecione pelo menos um registro.",
        confirmServicosExport: "Os serviços e pratos do grupo origem serão excluídos. Deseja continuar?",
        servicosExportSuccess: "Serviços exportados com sucesso.",
        confirmPratosExport: "Deseja excluir os pratos do grupo de prato no serviço de origem? (Se o serviço de origem estiver selecionado como destino, o prato será excluído no serviço de origem obrigatoriamente.)",
        pratosExportSuccess: "Pratos exportados com sucesso.",
        duplicatedMessageOnExport: "__nmprato__, pois já existe no serviço __cdservfili__ - __nmservico__, no grupo __nmgrupoprato__.",
        duplicatedTitleOnExport: "Pratos não exportados",
        sheetErrors: "Erros na planilha",
        procedureErrors: "Itens não importados",
        invalidSheetColumnsLabels: "Colunas da planilha inválidas. Certifique-se de que usou o modelo de planilha para importação.",
        invalidSheetColumnsNumber: "Número de colunas da planilha inválido. Certifique-se de que usou o modelo de planilha para importação.",
        invalidSheet: "Planilha inválida. Certifique-se de que usou o modelo de planilha para importação.",
        emptySheet: "Planilha sem dados.",
        errorOpeningSheet: "Erro ao carregar planilha. Certifique-se de que usou o modelo de planilha para importação.",
        serverPermissionError: "Não foi possível carregar a planilha no servidor: Permissão negada. Por favor, contate um administrador do sistema.",
        importSheetSuccess: "Planilha importada com sucesso."
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('cmp04700_fornecedor_nao_atende_atendeController',cmp04700_fornecedor_nao_atende_atendeController);
});